!= NAMELIST ѤҥȥǡϾѥ桼ƥƥ
!
!= Utilities for control of information about history data output with NAMELIST
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: dc_histnml.f90,v 1.8 2007/12/16 13:46:24 morikawa Exp $
! Tag Name::  $Name: gt4f90io-20080210 $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module dc_histnml
  !
  != NAMELIST ѤҥȥǡϾѥ桼ƥƥ
  !
  != Utilities for control of information about history data output with NAMELIST
  !
  ! <b>Note that Japanese and English are described in parallel.</b>
  !
  ! ͥǥΥҥȥǡϤξ NAMELIST ɤ߹
  ! ݤʥ桼ƥƥ󶡤ޤ. 
  !
  ! This module provides utilities for control of 
  ! information from NAMELIST about history data of numerical models.
  !
  !== Procedures List
  !
  ! Create        :: DCHSTNML ѿν
  ! Close         :: DCHSTNML ѿνλ
  ! PutLine       :: DCHSTNML ѿ˳ǼƤΰ
  ! initialized   :: DCHSTNML ѿꤵƤ뤫ݤ
  ! Add           :: ѿɲ
  ! Delete        :: ѿκ
  ! ResetDefault  :: ǥեΤߤ᤹
  ! Inquire       :: ѿ䤤碌
  ! output_valid  :: Ϥ꤬ͭǤ˿֤
  ! output_step   :: ߤλ郎ϤΥߥ󥰤ξ˿֤
  ! names         :: ϿƤѿ̾ꥹȤ֤
  ! ------------  :: ------------
  ! Create        :: Constructor of "DCHSTNML"
  ! Close         :: Deconstructor of "DCHSTNML"
  ! PutLine       :: Print information of "DCHSTNML"
  ! initialized   :: Check initialization of "DCHSTNML"
  ! Add           :: Add information of variables
  ! Delete        :: Delete information of variables
  ! ResetDefault  :: Reset to default settings
  ! Inquire       :: Inquire information of variables
  ! output_valid  :: True is returned when a configuration of output is valid
  ! output_step   :: True is returned when current time is output timing
  ! names         :: Return list of registerd variable names
  !
  !== Usage
  !
  !  줬ƤʤȤɤΤ褦˻ȤääѤʬʤΤ, 
  !    Ƚ񤭤ޤ礦. 
  ! 
  ! Ϥ, DCHSTNML ѿ, Create ǽԤޤ.
  !--
  ! ⥸塼ˡ򵭽ҤƤ.
  !++
  ! DCHSTNML ѿνλˤ Close ѤƤ.
  !
  ! First, initialize "DCHSTNML" by "Create".
  !--
  ! Describe usage of module
  !++
  ! In order to terminate "DCHSTNML", use "Close".
  !

  use dc_types, only: DP, TOKEN, STRING
  implicit none
  private
  public:: DCHSTNML, Create, Close, PutLine, initialized
  public:: Add, Delete, ResetDefault, Inquire
  public:: output_step, output_valid, names

  type DCHSTNML
    !
    ! NAMELIST ҥȥǡνϾ
    ! Ǽ뤿ι¤ǡǤ. 
    ! ޤ, Create  "DCHSTNML" ѿꤷƲ.
    ! ꤵ줿 "DCHSTNML" ѿѤݤˤ,
    ! Close ˤäƽλԤäƤ.
    !
    ! This derived type is worked in order to store information about 
    ! data output from NAMELIST. 
    ! Initialize "DCHSTNML" variable by "Create" before usage.
    ! If you reuse "DCHSTNML" variable again for another application, 
    ! terminate by "Close".
    !
    private
    logical:: initialized = .false.
                              ! ե饰. 
                              ! Initialization flag
    type(DCHSTNML_ENTRY), pointer:: hstnml_list =>null()
                              ! ѿȤξꥹ. 
                              ! ǼˤĤƤ
                              ! DCHSTNML_ENTRY 򻲾ȤΤ. 
                              !
                              ! Information list about individual variable 
                              ! See "DCHSTNML_ENTRY" 
                              ! about stored information. 
  end type DCHSTNML

  type DCHSTNML_ENTRY
    !
    ! ѿȤξǼ뤿ι¤ΤǤ. 
    ! ι¤Τϥ⥸塼ǻѤ뤳ȤꤷƤ뤿, 
    ! ⥸塼볰ϻѤʤǤ. 
    !
    ! Information about individual output variable is stored in
    ! this derived type.
    ! It is expected that this derived type is used
    ! internally, so do not refer from the outside.
    !
    character(TOKEN):: name
                              ! ѿ̾. Variable name
    character(STRING):: file
                              ! ҥȥǡΥե̾. 
                              ! History data filenames
    real(DP), pointer:: interval_value =>null()
                              ! ҥȥǡνϴֳ֤ο. 
                              ! ͤͿ, Ϥ޻ߤޤ. 
                              ! 
                              ! Numerical value for interval of history data output. 
                              ! Negative values suppresses output.
    character(TOKEN), pointer:: interval_unit =>null()
                              ! ҥȥǡνϴֳ֤ñ. 
                              ! Unit for interval of history data output
    character(TOKEN), pointer:: precision =>null()
                              ! ҥȥǡ. 
                              ! Precision of history data
    logical, pointer:: average =>null()
                              ! ϥǡʿѲե饰. 
                              ! Flag for average of output data.
    character(STRING), pointer:: fileprefix =>null()
                              ! ҥȥǡΥե̾Ƭ. 
                              ! Prefixes of history data filenames
    logical:: dummy0          ! 8 ӥåȶѤΥߡѿ. 
                              ! Dummy variable for 8 bit boundary
    type(DCHSTNML_ENTRY), pointer:: next =>null()
                              ! ꥹȹ¤Τѿ. 
                              ! A variable for a list structure
  end type DCHSTNML_ENTRY


  character(*), parameter:: version = &
    & '$Name: gt4f90io-20080210 $' // &
    & '$Id: dc_histnml.f90,v 1.8 2007/12/16 13:46:24 morikawa Exp $'

  !-----------------------------------------------------------------
  !  ³
  !  Public procedures
  !-----------------------------------------------------------------

  interface Create
    module procedure DCHistNmlCreate
  end interface

  interface Close
    module procedure DCHistNmlClose
  end interface

  interface PutLine
    module procedure DCHistNmlPutLine
  end interface

  interface initialized
    module procedure DCHistNmlInitialized
  end interface

  interface Add
    module procedure DCHistNmlAdd
  end interface

  interface Delete
    module procedure DCHistNmlDelete
  end interface

  interface ResetDefault
    module procedure DCHistNmlResetDefault
  end interface

  interface Inquire
    module procedure DCHistNmlInquire
  end interface

  interface output_step
    module procedure DCHistNmlOutputStep
  end interface

  interface output_valid
    module procedure DCHistNmlOutputValid
  end interface

  interface names
    module procedure DCHistNmlNames
  end interface

  !-----------------------------------------------------------------
  !  ³
  !  Private procedures
  !-----------------------------------------------------------------

  interface ListNext
    module procedure DCHistNmlListNext
  end interface

  interface ListLast
    module procedure DCHistNmlListLast
  end interface

  interface ListSearch
    module procedure DCHistNmlListSearch
  end interface

!!$  interface Sample
!!$    module procedure DCHistNmlSample
!!$  end interface

contains

  subroutine DCHistNmlCreate( hstnml, &
    & interval_value, &
    & interval_unit, &
    & precision, &
    & average, &
    & fileprefix, &
    & err )
    !
    ! DCHSTNML ѿνԤޤ. 
    ! ¾Υ֥롼ѤɬΥ֥롼ˤä 
    ! DCHSTNML ѿꤷƤ. 
    !
    ! *interval_value*, 
    ! *interval_unit*, 
    ! *precision*, 
    ! *average*
    ! ϥǥեͤȤꤵޤ. 
    ! *fileprefix* ϳѿνϥե̾ƬȤ
    ! Ѥޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml* ˽ꤵƤ, 
    ! ץϥ顼ȯޤ. 
    !
    ! Constructor of "DCHSTNML". 
    ! Initialize *hstnml* by this subroutine, 
    ! before other procedures are used, 
    !
    ! *interval_value*, 
    ! *interval_unit*, 
    ! *precision*, 
    ! *average* 
    ! are set as default values. 
    ! *fileprefix* is used as prefixes of output filenames of 
    ! each variable. 
    !
    ! Note that if *hstnml* is already initialized 
    ! by this procedure, error is occurred. 
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_present, only: present_and_not_empty, present_and_true, present_select
    use dc_message, only: MessageNotify
    use dc_error, only: StoreError, DC_NOERR, DC_EALREADYINIT, &
      & DC_EARGLACK, DC_ENEGATIVE, DC_ENOFILEREAD, USR_ERRNO
    use dc_date_types, only: DC_DIFFTIME
    use dc_date, only: Create
    implicit none
    type(DCHSTNML), intent(inout):: hstnml
    real(DP), intent(in), optional:: interval_value
                              ! ҥȥǡνϴֳ֤ο. 
                              ! ͤͿ, Ϥ޻ߤޤ. 
                              ! 
                              ! Numerical value for interval of history data output. 
                              ! Negative values suppresses output.
    character(*), intent(in), optional:: interval_unit
                              ! ҥȥǡνϴֳ֤ñ. 
                              ! Unit for interval of history data output
    character(*), intent(in), optional:: precision
                              ! ҥȥǡ. 
                              ! Precision of history data
    logical, intent(in), optional:: average
                              ! ϥǡʿѲե饰. 
                              ! Flag for average of output data.
    character(*), intent(in), optional:: fileprefix
                              ! ҥȥǡΥե̾Ƭ. 
                              ! Prefixes of history data filenames
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DC_DIFFTIME):: interval_time
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlCreate'
  continue
    call BeginSub( subname, &
      & fmt = '@interval_value=%f @interval_unit=%c @precision=%c @average=%y @fileprefix=%c', &
      & d  = (/ present_select(.true., -1.0_DP, interval_value) /), &
      & c1 = trim( present_select(.true., '<no>', interval_unit) ), &
      & c2 = trim( present_select(.true., '<no>', precision) ), &
      & l  = (/ present_and_true(average) /), &
      & c3 = trim( present_select(.true., '<no>', fileprefix) ), &
      & version = version )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( hstnml % initialized ) then
      stat = DC_EALREADYINIT
      cause_c = 'DCHSTNML'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  
    !  Allocate
    !-----------------------------------------------------------------
    allocate( hstnml % hstnml_list )
    nullify( hstnml % hstnml_list % next )

    !-----------------------------------------------------------------
    !  ǥեͤ
    !  Configure default values
    !-----------------------------------------------------------------
    hstnml % hstnml_list % name = ''
    hstnml % hstnml_list % file = ''

    allocate( hstnml % hstnml_list % interval_value )
    allocate( hstnml % hstnml_list % interval_unit  )
    allocate( hstnml % hstnml_list % precision      )
    allocate( hstnml % hstnml_list % average        )
    allocate( hstnml % hstnml_list % fileprefix    )
    hstnml % hstnml_list % interval_value = -1.0_DP
    hstnml % hstnml_list % interval_unit  = 'sec'
    hstnml % hstnml_list % precision      = 'float'
    hstnml % hstnml_list % average        = .false.
    hstnml % hstnml_list % fileprefix     = ''

    if ( present(interval_value) ) hstnml % hstnml_list % interval_value = interval_value
    if ( present(interval_unit)  ) hstnml % hstnml_list % interval_unit  = interval_unit 
    if ( present(precision)      ) hstnml % hstnml_list % precision      = precision     

    if ( present(average)        ) hstnml % hstnml_list % average        = average       
    if ( present(fileprefix)     ) hstnml % hstnml_list % fileprefix     = fileprefix    

    !-----------------------------------------------------------------
    !  ֤ñ̤Υå
    !  Check unit of time
    !-----------------------------------------------------------------
    call Create( &
      & diff = interval_time, &                          ! (out)
      & value = hstnml % hstnml_list % interval_value, & ! (in)
      & unit = hstnml % hstnml_list % interval_unit, &   ! (in)
      & err = err )                                      ! (out)
    if ( present_and_true( err ) ) then
      stat = USR_ERRNO
      goto 999
    end if

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    hstnml % initialized = .true.
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlCreate

  subroutine DCHistNmlClose( hstnml, err )
    !
    ! DCHSTNML ѿνλԤޤ. 
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! Deconstructor of "DCHSTNML". 
    ! Note that if *hstnml* is not initialized by "Create" yet, 
    ! error is occurred. 
    !
    use dc_trace, only: BeginSub, EndSub, DbgMessage
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    implicit none
    type(DCHSTNML), intent(inout):: hstnml
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    type(DCHSTNML_ENTRY), pointer:: hptr_prev =>null()
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlClose'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCHSTNML'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  "DCHSTNML" ξõ
    !  Clear the settings for "DCHSTNML"
    !-----------------------------------------------------------------
    do 
      hptr => hstnml % hstnml_list
      call ListLast( hstnml_list = hptr, & ! (inout)
        & previous = hptr_prev )           ! (out)
      call DbgMessage( 'remove entry (%c)', c1 = trim(hptr % name) )
      if ( trim( hptr % name ) == '' ) exit
      deallocate( hptr )
      nullify( hptr_prev % next )
    end do
    deallocate( hstnml % hstnml_list )

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    hstnml % initialized = .false.
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlClose

  subroutine DCHistNmlPutLine( hstnml, unit, indent, err )
    !
    !  *hstnml* ꤵƤޤ. 
    ! ǥեȤǤϥåɸϤ˽Ϥޤ. 
    ! *unit* ֹꤹ뤳Ȥ, ѹ뤳ȤǽǤ. 
    !
    ! Print information of *hstnml*. 
    ! By default messages are output to standard output. 
    ! Unit number for output can be changed by *unit* argument. 
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    implicit none
    type(DCHSTNML), intent(in):: hstnml
    integer, intent(in), optional:: unit
                              ! ֹ. 
                              ! ǥեȤνɸ. 
                              !
                              ! Unit number for output. 
                              ! Default value is standard output. 
    character(*), intent(in), optional:: indent
                              ! ɽåλ. 
                              !
                              ! Indent of displayed messages. 
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    integer:: stat
    character(STRING):: cause_c
    integer:: out_unit
    integer:: indent_len
    character(STRING):: indent_str
    character(*), parameter:: subname = 'DCHistNmlPutLine'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( present(unit) ) then
      out_unit = unit
    else
      out_unit = STDOUT
    end if

    indent_len = 0
    indent_str = ''
    if ( present(indent) ) then
      if ( len(indent) /= 0 ) then
        indent_len = len(indent)
        indent_str(1:indent_len) = indent
      end if
    end if

    !-----------------------------------------------------------------
    !  "DCHSTNML" ΰ
    !  Print the settings for "DCHSTNML"
    !-----------------------------------------------------------------
    if ( hstnml % initialized ) then
      call Printf( out_unit, &
        & indent_str(1:indent_len) // &
        & '#<DCHSTNML:: @initialized=%y', &
        & l = (/hstnml % initialized/) )

      hptr => hstnml % hstnml_list

      do while ( associated( hptr ) )

        call Printf( out_unit, &
          & indent_str(1:indent_len) // &
          & ' #<DCHSTNML_ENTRY:: @name=%c @file=%c', &
          & c1 = trim(hptr % name), &
          & c2 = trim(hptr % file) )

        call Printf( out_unit, &
          & indent_str(1:indent_len) // &
          & '  @interval_value=%f @interval_unit=%c', &
          & d = (/hptr % interval_value/), &
          & c1 = trim(hptr % interval_unit) )

        call Printf( out_unit, &
          & indent_str(1:indent_len) // &
          & '  @precision=%c @average=%y', &
          & c1 = trim(hptr % precision), &
          & l = (/ hptr % average /) )

        call Printf( out_unit, &
          & indent_str(1:indent_len) // &
          & '  @fileprefix=%c', &
          & c1 = trim(hptr % fileprefix) )

        call ListNext( hstnml_list = hptr ) ! (inout)
      end do

      call Printf( out_unit, &
        & indent_str(1:indent_len) // &
        & ' >' )

      call Printf( out_unit, &
        & indent_str(1:indent_len) // &
        & '>' )
    else
      call Printf( out_unit, &
        & indent_str(1:indent_len) // &
        & '#<DCHSTNML:: @initialized=%y>', &
        & l = (/hstnml % initialized/) )
    end if

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlPutLine

  logical function DCHistNmlInitialized( hstnml ) result(result)
    !
    ! *hstnml* ꤵƤˤ .true. , 
    ! ꤵƤʤˤ .false. ֤ޤ. 
    !
    ! If *hstnml* is initialized, .true. is returned. 
    ! If *hstnml* is not initialized, .false. is returned. 
    !
    implicit none
    type(DCHSTNML), intent(in):: hstnml
  continue
    result = hstnml % initialized
  end function DCHistNmlInitialized

  recursive subroutine DCHistNmlAdd( hstnml, &
    & name, file, &
    & interval_value, &
    & interval_unit, &
    & precision, &
    & average, &
    & fileprefix, &
    & err )
    !
    ! ѿνϾäޤ. 
    !
    ! ǥեͤꤹˤ, *name* Ϳʤ, ޤ
    ! *name* ˶ͿƤ. 
    ! ǥեͤͿ, *file* Ϳ̵뤵ޤ. 
    ! *fileprefix* ϥǥեͤͿΤͭǤ. 
    !
    ! *name* ѿ̾ꤵ, κݤ *file* Ϳʤ, 
    ! ޤ϶Ϳ, *file* ˤ 
    ! "<i><*name* Ϳ줿ʸ></i>.nc" ꤵޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! Add output information of a variable.
    ! 
    ! In order to set default values, specify blank to *name* or
    ! do not specify *name*.
    ! When default values are specified, *file* is ignored. 
    ! *fileprefix* is valid only when default values are specified. 
    !
    ! When a variable name is specified to *name* and 
    ! *file* is not specified or blanks are specified to *file*,
    ! "<i><string given to *name*></i>.nc" is specified to *file*.
    !
    ! If *hstnml* is not initialized by "Create" yet, 
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub, DbgMessage
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_present, only: present_and_not_empty, present_and_true, present_select
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_date_types, only: DC_DIFFTIME
    use dc_date, only: Create
    use dc_message, only: MessageNotify
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT, DC_EARGLACK, USR_ERRNO
    implicit none
    type(DCHSTNML), intent(inout):: hstnml
    character(*), intent(in), optional:: name
                              ! ѿ̾. 
                              ! 
                              ! Ƭζ̵뤵ޤ. 
                              ! 
                              ! "Data1,Data2" Τ褦˥ޤǶڤäʣ
                              ! ѿꤹ뤳ȤǽǤ. , 
                              ! κݤˤ, *file* Ϳ
                              ! ̵뤵ޤ. ¾ξϤ줾
                              ! ѿξȤꤵޤ. 
                              ! 
                              ! Variable name. 
                              ! 
                              ! Blanks at the head of the name are ignored. 
                              ! 
                              ! Multiple variables can be specified 
                              ! as "Data1,Data2" too. Delimiter is comma. 
                              ! In this case, *file* is ignored, and 
                              ! other information is set to each variable.
                              ! 
    character(*), intent(in), optional:: file
                              ! ҥȥǡΥե̾. 
                              ! History data filenames
    real(DP), intent(in), optional:: interval_value
                              ! ҥȥǡνϴֳ֤ο. 
                              ! ͤͿ, Ϥ޻ߤޤ. 
                              ! 
                              ! Numerical value for interval of history data output. 
                              ! Negative values suppresses output.
    character(*), intent(in), optional:: interval_unit
                              ! ҥȥǡνϴֳ֤ñ. 
                              ! Unit for interval of history data output
    character(*), intent(in), optional:: precision
                              ! ҥȥǡ. 
                              ! Precision of history data
    logical, intent(in), optional:: average
                              ! ϥǡʿѲե饰. 
                              ! Flag for average of output data.
    character(*), intent(in), optional:: fileprefix
                              ! ҥȥǡΥե̾Ƭ. 
                              ! Prefixes of history data filenames
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    type(DCHSTNML_ENTRY), pointer:: hptr_last =>null()
    type(DC_DIFFTIME):: interval_time
    character(TOKEN), pointer:: varnames_array(:) =>null()
    integer:: i, vnmax
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlAdd'
  continue
    call BeginSub( subname, &
      & fmt = '@name=%a @file=%a @interval_value=%f @interval_unit=%a @precision=%a @average=%y @fileprefix=%a', &
      & d  = (/ present_select(.true., -1.0_DP, interval_value) /), &
      & l  = (/ present_and_true(average) /), &
      & ca = StoA( present_select(.true., '<no>', name), &
      &            present_select(.true., '<no>', file), &
      &            present_select(.true., '<no>', interval_unit), &
      &            present_select(.true., '<no>', precision), &
      &            present_select(.true., '<no>', fileprefix) ) &
      & )

    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCHSTNML'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  ʣѿꤹ
    !  Configure multiple variables
    !-----------------------------------------------------------------
    if ( present_and_not_empty(name) ) then
      if ( index(name, ',') > 0 ) then
        call DbgMessage( 'multiple entries (%c) will be created', c1 = trim(name) )
        if ( present(file) ) call DbgMessage( 'argument @file=%c is ignored', c1 = trim(file) )

        call Split( str = name, sep = ',', & ! (in)
          & carray = varnames_array )        ! (out)
        vnmax = size( varnames_array )

        do i = 1, vnmax
          call Add( hstnml = hstnml, &           ! (inout)
            & name = varnames_array(i), &        ! (in)
            & interval_value = interval_value, & ! (in)
            & interval_unit = interval_unit, &   ! (in)
            & precision = precision, &           ! (in)
            & average = average, &               ! (in)
            & err = err )                        ! (out)
          if ( present_and_true( err ) ) then
            deallocate( varnames_array )
            stat = USR_ERRNO
            goto 999
          end if
        end do
        deallocate( varnames_array )
        goto 999
      end if
    end if

    !-----------------------------------------------------------------
    !  *hstnml* ؾɲ.
    !  Add information to *hstnml*
    !-----------------------------------------------------------------
    if ( .not. present_and_not_empty(name) ) then
      if ( present(interval_value) ) hstnml % hstnml_list % interval_value = interval_value
      if ( present(interval_unit)  ) hstnml % hstnml_list % interval_unit  = interval_unit 
      if ( present(precision)      ) hstnml % hstnml_list % precision      = precision     
      if ( present(average)        ) hstnml % hstnml_list % average        = average       
      if ( present(fileprefix)     ) hstnml % hstnml_list % fileprefix     = fileprefix    

      hptr => hstnml % hstnml_list

    else
      hptr => hstnml % hstnml_list
      call ListSearch( hstnml_list = hptr, & ! (inout)
        &              name = name )         ! (in)
      if ( .not. associated(hptr) ) then
        call DbgMessage( 'new entry (%c) is created', c1 = trim( adjustl( name ) ) )

        hptr_last => hstnml % hstnml_list
        call ListLast( hstnml_list = hptr_last ) ! (inout)
        allocate( hptr )

        nullify( hptr % next )

        hptr % interval_value => hstnml % hstnml_list % interval_value 
        hptr % interval_unit  => hstnml % hstnml_list % interval_unit  
        hptr % precision      => hstnml % hstnml_list % precision      
        hptr % average        => hstnml % hstnml_list % average        
        hptr % fileprefix     => hstnml % hstnml_list % fileprefix     

        hptr_last % next => hptr
      else
        call DbgMessage( 'entry (%c) is overwritten', c1 = trim( adjustl( name ) ) )
      end if

      hptr % name  = adjustl( name )
      if ( present_and_not_empty(file) ) then
        hptr % file = file
        nullify(  hptr % fileprefix )
        allocate( hptr % fileprefix )
        hptr % fileprefix = ''
      else
        hptr % file = trim(name) // '.nc'
      end if

      if ( present(interval_value) ) then
        nullify(  hptr % interval_value )
        allocate( hptr % interval_value )
        hptr % interval_value = interval_value 
      end if
      if ( present(interval_unit)  ) then
        nullify(  hptr % interval_unit  )
        allocate( hptr % interval_unit  )
        hptr % interval_unit  = interval_unit  
      end if
      if ( present(precision)      ) then
        nullify(  hptr % precision      )
        allocate( hptr % precision      )
        hptr % precision      = precision      
      end if
      if ( present(average)        ) then
        nullify(  hptr % average        )
        allocate( hptr % average        )
        hptr % average        = average        
      end if

    end if

    !---------------------------------------------------------------
    !  ֤ñ̤Υå
    !  Check unit of time
    !---------------------------------------------------------------
    call Create( &
      & diff = interval_time, &          ! (out)
      & value = hptr % interval_value, & ! (in)
      & unit = hptr % interval_unit, &   ! (in)
      & err = err )                      ! (out)
    if ( present_and_true( err ) ) then
      call Delete( hstnml = hstnml, &    ! (inout)
        & name = name )                  ! (in)
      stat = USR_ERRNO
      goto 999
    end if

    nullify( hptr )

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlAdd

  recursive subroutine DCHistNmlDelete( hstnml, &
    & name, &
    & err )
    !
    ! ѿνϾޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! Delete output information of a variable.
    ! 
    ! If *hstnml* is not initialized by "Create" yet, 
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub, DbgMessage
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_present, only: present_and_not_empty, present_and_true
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT, DC_EARGLACK, USR_ERRNO
    implicit none
    type(DCHSTNML), intent(inout):: hstnml
    character(*), intent(in):: name
                              ! ѿ̾. 
                              ! 
                              ! Ƭζ̵뤵ޤ. 
                              ! 
                              ! "Data1,Data2" Τ褦˥ޤǶڤäʣ
                              ! ѿꤹ뤳ȤǽǤ. 
                              ! 
                              ! Variable name. 
                              ! 
                              ! Blanks at the head of the name are ignored. 
                              ! 
                              ! Multiple variables can be specified 
                              ! as "Data1,Data2". Delimiter is comma. 
                              ! 
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    type(DCHSTNML_ENTRY), pointer:: hptr_prev =>null()
    type(DCHSTNML_ENTRY), pointer:: hptr_next =>null()
    character(TOKEN), pointer:: varnames_array(:) =>null()
    integer:: i, vnmax
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlDelete'
  continue
    call BeginSub( subname, &
      & fmt = '@name=%c', &
      & c1 = trim( name ) )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCHSTNML'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  ʣѿ
    !  Delete multiple variables
    !-----------------------------------------------------------------
    if ( present_and_not_empty(name) ) then
      if ( index(name, ',') > 0 ) then
        call DbgMessage( 'multiple entries (%c) will be deleted', c1 = trim(name) )
        call Split( str = name, sep = ',', & ! (in)
          & carray = varnames_array )        ! (out)
        vnmax = size( varnames_array )

        do i = 1, vnmax
          call Delete( hstnml = hstnml, &           ! (inout)
            & name = varnames_array(i), &        ! (in)
            & err = err )                        ! (out)
          if ( present_and_true( err ) ) then
            deallocate( varnames_array )
            stat = USR_ERRNO
            goto 999
          end if
        end do
        deallocate( varnames_array )
        goto 999
      end if
    end if

    !-----------------------------------------------------------------
    !  *hstnml* ξ.
    !  Delete information in *hstnml*
    !-----------------------------------------------------------------
    hptr => hstnml % hstnml_list
    call ListSearch( hstnml_list = hptr, &   ! (inout)
      &              name = name, &          ! (in)
      &              previous = hptr_prev, & ! (out)
      &              next = hptr_next )      ! (out)

    if ( .not. associated( hptr ) ) goto 999
    if ( ( trim(hptr % name) /= '' ) .and. associated( hptr_prev ) ) then
      call DbgMessage( 'entry (%c) is deleted', c1 = trim( adjustl( name ) ) )
      hptr_prev % next => hptr_next
      deallocate( hptr )
    end if

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlDelete

  subroutine DCHistNmlResetDefault( hstnml, err )
    !
    ! ǥեͤĤ, Ͽǡޤ.
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! Stored data is deleted without default settings. 
    !
    ! If *hstnml* is not initialized by "Create" yet, 
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
    implicit none
    type(DCHSTNML), intent(inout):: hstnml
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    character(STRING):: varnames
    character(TOKEN), pointer:: varnames_array(:) =>null()
    integer:: i, vnmax
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlResetDefault'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCHSTNML'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  ѿ̾ꥹȤμ
    !  Get varnames list
    !-----------------------------------------------------------------
    varnames = names( hstnml )
    call Split( str = varnames, sep = ',', & ! (in)
      & carray = varnames_array )            ! (out)
    vnmax = size( varnames_array )

    do i = 1, vnmax
      call Delete( hstnml = hstnml, & ! (inout)
        & name = varnames_array(i) )  ! (in)
    end do

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlResetDefault

  subroutine DCHistNmlInquire( hstnml, &
    & name, &
    & file, &
    & interval_value, &
    & interval_unit, &
    & precision, &
    & average, &
    & fileprefix, &
    & err )
    !
    ! ѿνϾޤ. 
    !
    ! ǥեͤˤ, *name* Ϳʤ, ޤ
    ! *name* ˶ͿƤ. 
    !
    ! *name* ˴ؤǡ¸ߤʤ, 顼ȯޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! Inquire output information of a variable.
    ! 
    ! If data correspond to *name* is not found, 
    ! error is occurred. 
    !
    ! If *hstnml* is not initialized by "Create" yet, 
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_present, only: present_and_not_empty, present_and_true
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT, DC_EARGLACK, DC_ENOENTRY
    implicit none
    type(DCHSTNML), intent(in):: hstnml
    character(*), intent(in), optional:: name
                              ! ѿ̾. 
                              ! Ƭζ̵뤵ޤ. 
                              ! 
                              ! Variable name. 
                              ! Blanks at the head of the name are ignored. 
    character(*), intent(out), optional:: file
                              ! ҥȥǡΥե̾. 
                              ! History data filenames
    real(DP), intent(out), optional:: interval_value
                              ! ҥȥǡνϴֳ֤ο. 
                              ! ͤͿ, Ϥ޻ߤޤ. 
                              ! 
                              ! Numerical value for interval of history data output. 
                              ! Negative values suppresses output.
    character(*), intent(out), optional:: interval_unit
                              ! ҥȥǡνϴֳ֤ñ. 
                              ! Unit for interval of history data output
    character(*), intent(out), optional:: precision
                              ! ҥȥǡ. 
                              ! Precision of history data
    logical, intent(out), optional:: average
                              ! ϥǡʿѲե饰. 
                              ! Flag for average of output data.
    character(*), intent(out), optional:: fileprefix
                              ! ҥȥǡΥե̾Ƭ. 
                              ! Prefixes of history data filenames

    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlInquire'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'DCHSTNML'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  *hstnml* ؾɲ.
    !  Inquire information to *hstnml*
    !-----------------------------------------------------------------
    hptr => hstnml % hstnml_list
    call ListSearch( hstnml_list = hptr, &   ! (inout)
      &              name = name )           ! (in)

    if ( .not. associated( hptr ) ) then
      stat = DC_ENOENTRY
      cause_c = adjustl( name )
      goto 999
    end if

    if ( hptr % name == '' ) then
      if ( present(file)           ) file           = ''
    else
      if ( present(file)           ) file           = trim( hptr % fileprefix ) // hptr % file
    end if
    if ( present(interval_value) ) interval_value = hptr % interval_value
    if ( present(interval_unit)  ) interval_unit  = hptr % interval_unit 
    if ( present(precision)      ) precision      = hptr % precision     
    if ( present(average)        ) average        = hptr % average       
    if ( present(fileprefix)     ) fileprefix     = hptr % fileprefix    

    nullify( hptr )

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlInquire

  logical function DCHistNmlOutputStep( hstnml, &
    & name, time ) result(result)
    !
    ! *time* ѿ *name* νϤ륿ߥ󥰤Ǥ
    ! .true. , Ǥʤ .false. ֤ޤ. 
    ! *hstnml* ꤵƤʤˤ .false. ֤ޤ. 
    ! *name* ˴ؤǡ¸ߤʤˤ .false. ֤ޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! If *time* is the time that a variable *name* is output,
    ! .true. is returned, otherwise .false. is returned
    ! When *hstnml* is not initialized, .false. is returned too.
    ! When data correspond to *name* is not found, .false. is returned too.
    ! 
    ! If *hstnml* is not initialized by "Create" yet, 
    ! error is occurred.
    !
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_present, only: present_and_not_empty, present_and_true
    use dc_date_types, only: DC_DIFFTIME
    use dc_date, only: Create, mod, operator(==), toChar
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    implicit none
    type(DCHSTNML), intent(in):: hstnml
    character(*), intent(in):: name
                              ! ѿ̾. 
                              ! Ƭζ̵뤵ޤ. 
                              ! 
                              ! Variable name. 
                              ! Blanks at the head of the name are ignored. 
    type(DC_DIFFTIME), intent(in):: time
                              ! ߻. Current time

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    type(DC_DIFFTIME):: interval_time
!!$    character(*), parameter:: subname = 'DCHistNmlOutputStep'
  continue

    result = .false.

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) goto 999

    !-----------------------------------------------------------------
    !  Ǽѿؤη
    !  Associate a variable storing information
    !-----------------------------------------------------------------
    hptr => hstnml % hstnml_list
    call ListSearch( hstnml_list = hptr, &   ! (inout)
      &              name = name )           ! (in)

    if ( .not. associated( hptr ) ) goto 999

    !-----------------------------------------------------------------
    !  Υå
    !  Check time
    !-----------------------------------------------------------------
    if ( .not. hptr % interval_value > 0.0_DP ) goto 999

    call Create( &
      & diff = interval_time, &          ! (out)
      & value = hptr % interval_value, & ! (in)
      & unit = hptr % interval_unit )    ! (in)

    if ( mod( time, interval_time ) == 0 ) then
      result = .true.
    end if

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    nullify( hptr )
  end function DCHistNmlOutputStep

  logical function DCHistNmlOutputValid( hstnml, &
    & name ) result(result)
    !
    ! ѿ *name* νϤͭǤ, 
    ! .true. , Ǥʤ .false. ֤ޤ. 
    ! *hstnml* ꤵƤʤˤ .false. ֤ޤ. 
    ! *name* ˴ؤǡ¸ߤʤˤ .false. ֤ޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ. 
    !
    ! If output of a variable *name* is valid, 
    ! .true. is returned, otherwise .false. is returned
    ! When *hstnml* is not initialized, .false. is returned too.
    ! When data correspond to *name* is not found, .false. is returned too.
    ! 
    ! If *hstnml* is not initialized by "Create" yet, 
    ! error is occurred.
    !
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_present, only: present_and_not_empty, present_and_true
    use dc_date_types, only: DC_DIFFTIME
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    implicit none
    type(DCHSTNML), intent(in):: hstnml
    character(*), intent(in):: name
                              ! ѿ̾. 
                              ! Ƭζ̵뤵ޤ. 
                              ! 
                              ! Variable name. 
                              ! Blanks at the head of the name are ignored. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
!!$    character(*), parameter:: subname = 'DCHistNmlOutputValid'
  continue

    result = .false.

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) goto 999

    !-----------------------------------------------------------------
    !  Ǽѿؤη
    !  Associate a variable storing information
    !-----------------------------------------------------------------
    hptr => hstnml % hstnml_list
    call ListSearch( hstnml_list = hptr, &   ! (inout)
      &              name = name )           ! (in)

    if ( .not. associated( hptr ) ) goto 999

    !-----------------------------------------------------------------
    !  ϤͭΥå
    !  Check validity of output
    !-----------------------------------------------------------------
    if ( hptr % interval_value > 0.0_DP ) then
      result = .true.
      goto 999
    end if

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    nullify( hptr )
  end function DCHistNmlOutputValid

  character(STRING) function DCHistNmlNames( hstnml ) result(result)
    !
    ! *hstnml* ꤵƤѿꥹȤ򥫥ޤǤĤʤ
    ! ֤ޤ. 
    !
    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
    ! Ƥʤ, ʸ֤ޤ. 
    !
    ! List of variables registered in *hstnml* is join with ',', 
    ! and returned. 
    ! 
    ! If *hstnml* is not initialized by "Create" yet, 
    ! blank is returned. 
    !
    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
    use dc_types, only: DP, STRING, TOKEN, STDOUT
    implicit none
    type(DCHSTNML), intent(in):: hstnml

    !-----------------------------------
    !  ѿ
    !  Work variables
    type(DCHSTNML_ENTRY), pointer:: hptr =>null()
    logical:: first
!!$    character(*), parameter:: subname = 'DCHistNmlNames'
  continue

    result = ''
    first = .true.

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if ( .not. hstnml % initialized ) goto 999

    !-----------------------------------------------------------------
    !  μФ
    !  Fetch information
    !-----------------------------------------------------------------
    hptr => hstnml % hstnml_list
    do while ( associated( hptr % next ) )
      call ListNext( hstnml_list = hptr ) ! (inout)
      if ( first ) then
        result = adjustl( hptr % name )
        first = .false.
      else
        result = trim( result ) // ',' // adjustl( hptr % name )
      end if
    end do

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    nullify( hptr )
  end function DCHistNmlNames

  subroutine DCHistNmlListNext( &
    & hstnml_list, err )
    !
    ! ꥹȹ¤Ǥ *hstnml_list* (DCHSTNML_ENTRY ) , 
    ! Υȥ *hstnml_list* ˺Ʒ礷֤ޤ. 
    ! Υȥ̵꤬, *hstnml_list* κǸΥȥ 
    ! *next* () ³֤ޤ. 
    ! *hstnml_list* Ϥᤫξˤ϶֤֤ޤ. 
    !
    ! *hstnml_list* (type "DCHSTNML_ENTRY") that is a list structure 
    ! is recieved, and *hstnml_list* is reassociated to next entry, and
    ! is returned. 
    ! If next entry is not found, *hstnml_list* is associated to 
    ! *next* in last entry (null), and returned. 
    ! If *hstnml_list* is null from the beginning, null is returned.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_error, only: StoreError, DC_NOERR
    implicit none
    type(DCHSTNML_ENTRY), pointer:: hstnml_list
                              ! (inout)
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlListNext'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  ֤ξϲ⤷ʤ֤
    !  If null, return without change
    !-----------------------------------------------------------------
    if ( .not. associated( hstnml_list ) ) goto 999

    !-----------------------------------------------------------------
    !  Υȥ˷礷֤
    !  Next entry is associated, and returned
    !-----------------------------------------------------------------
    hstnml_list => hstnml_list % next

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlListNext

  subroutine DCHistNmlListLast( &
    & hstnml_list, previous, err )
    !
    ! ꥹȹ¤Ǥ *hstnml_list* (DCHSTNML_ENTRY ) , 
    ! ǸΥȥ˺Ʒ礷֤ޤ. 
    ! *hstnml_list* Ϥᤫξˤ϶֤֤ޤ. 
    !
    ! *previous* Ϳ, ȥΰ
    ! ȥ˷礷ޤ. 
    !
    ! *hstnml_list* (type "DCHSTNML_ENTRY") that is a list structure 
    ! is recieved, and *hstnml_list* is reassociated to 
    ! last entry, and returned. 
    ! If *hstnml_list* is null from the beginning, null is returned.
    !
    ! If *previous* is given, an entry previous to the above entry
    ! is associated. 
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_error, only: StoreError, DC_NOERR
    implicit none
    type(DCHSTNML_ENTRY), pointer:: hstnml_list
                              ! (inout)
    type(DCHSTNML_ENTRY), pointer, optional:: previous
                              ! (out)
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlListLast'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    if ( present( previous ) ) nullify( previous )

    !-----------------------------------------------------------------
    !  ֤ξϲ⤷ʤ֤
    !  If null, return without change
    !-----------------------------------------------------------------
    if ( .not. associated( hstnml_list ) ) goto 999

    !-----------------------------------------------------------------
    !  ǸΥȥ *next* ˷礷֤
    !  "*next*" in last entry is associated, and returned
    !-----------------------------------------------------------------
    do while ( associated( hstnml_list % next ) )
      if ( present( previous ) ) previous => hstnml_list
      call ListNext( hstnml_list = hstnml_list ) ! (inout)
    end do

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlListLast

  subroutine DCHistNmlListSearch( &
    & hstnml_list, name, &
    & previous, next, err )
    !
    ! ꥹȹ¤Ǥ *hstnml_list* (DCHSTNML_ENTRY ) , 
    !  *name* Ʊͤĥȥ˺Ʒ礷֤ޤ. 
    ! Ĥʤ϶֤֤ޤ.
    ! *hstnml_list* Ϥᤫξˤ϶֤֤ޤ. 
    ! 
    ! *previous* Ϳ, ȥΰ
    ! ȥ˷礷ޤ. Υȥ̵꤬ˤ
    ! ֤֤ޤ. 
    !
    ! *next* Ϳ, ȥΰĸ
    ! ȥ˷礷ޤ. Υȥ̵꤬ˤ
    ! ֤֤ޤ. 
    ! 
    ! *hstnml_list* (type "DCHSTNML_ENTRY") that is a list structure 
    ! is recieved, and *hstnml_list* is reassociated to 
    ! the entry that has a value that is same as argument *name*, 
    ! and returned. 
    ! If the entry is not found, null is returned. 
    ! If *hstnml_list* is null from the beginning, null is returned. 
    !
    ! If *previous* is given, an entry previous to the above entry
    ! is associated. If previous entries are not found, 
    ! null is returned.
    !
    ! If *next* is given, an entry next to the above entry
    ! is associated. If next entries are not found, 
    ! null is returned.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_error, only: StoreError, DC_NOERR
    implicit none
    type(DCHSTNML_ENTRY), pointer:: hstnml_list
                              ! (inout)
    character(*), intent(in):: name
                              ! ѿ̾. 
                              ! Ƭζ̵뤵ޤ. 
                              ! 
                              ! Variable name. 
                              ! Blanks at the head of the name are ignored. 
    type(DCHSTNML_ENTRY), pointer, optional:: previous
                              ! (out)
    type(DCHSTNML_ENTRY), pointer, optional:: next
                              ! (out)
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰. 
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ. 
                              !  *err* Ϳ, 
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ. 
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'DCHistNmlListSearch'
  continue
    call BeginSub( subname )
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  ֤ξϲ⤷ʤ֤
    !  If null, return without change
    !-----------------------------------------------------------------
    if ( .not. associated( hstnml_list ) ) goto 999

    !-----------------------------------------------------------------
    !   *name* Ʊ *name* ĥȥõ
    !  The entry that has *name* that is same as argument *name* is searched
    !-----------------------------------------------------------------
    if ( present( previous ) ) nullify( previous )
    if ( present( next ) ) nullify( next )
    if ( trim( adjustl( hstnml_list % name ) ) == trim( adjustl( name ) ) ) then
      if ( present( next ) ) then
        next => hstnml_list % next
      end if
      goto 999
    end if

    do while ( associated( hstnml_list ) )
      if ( present( previous ) ) previous => hstnml_list
      call ListNext( hstnml_list = hstnml_list ) ! (inout)
      if ( .not. associated( hstnml_list ) ) goto 999
      if ( trim( adjustl( hstnml_list % name ) ) == trim( adjustl( name ) ) ) then
        if ( present( next ) ) then
          next => hstnml_list % next
        end if
        goto 999
      end if
    end do

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub( subname )
  end subroutine DCHistNmlListSearch

!!$  subroutine DCHistNmlSample( hstnml, err )
!!$    !--
!!$    ! DCHistNmlSample 򵭽ҤƤ. 
!!$    !++
!!$    ! ʤ, Ϳ줿 *hstnml*  Create ˤäƽ
!!$    ! Ƥʤ, ץϥ顼ȯޤ. 
!!$    !--
!!$    ! Describe brief of "DCHistNmlSample". 
!!$    !++
!!$    ! If *hstnml* is not initialized by "Create" yet, 
!!$    ! error is occurred.
!!$    !
!!$    use dc_trace, only: BeginSub, EndSub
!!$    use dc_string, only: PutLine, Printf, Split, StrInclude, StoA, JoinChar
!!$    use dc_types, only: DP, STRING, TOKEN, STDOUT
!!$    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT
!!$    implicit none
!!$    type(DCHSTNML), intent(inout):: hstnml
!!$    logical, intent(out), optional:: err
!!$                              ! 㳰ѥե饰. 
!!$                              ! ǥեȤǤ, μ³ǥ顼
!!$                              ! , ץ϶λޤ. 
!!$                              !  *err* Ϳ, 
!!$                              ! ץ϶λ, 
!!$                              ! *err*  .true. ޤ. 
!!$                              !
!!$                              ! Exception handling flag. 
!!$                              ! By default, when error occur in 
!!$                              ! this procedure, the program aborts. 
!!$                              ! If this *err* argument is given, 
!!$                              ! .true. is substituted to *err* and 
!!$                              ! the program does not abort. 
!!$
!!$    !-----------------------------------
!!$    !  *hstnml* Ф
!!$    !  Setting values fetched from *hstnml*
!!$!!$    real(DP):: CoefAlpha      ! $ \alpha $ . . Coefficient
!!$!!$    real(DP):: DelTime        ! $ \Delta t $ . ॹƥå. Time step
!!$
!!$    !-----------------------------------
!!$    !  ѿ
!!$    !  Work variables
!!$    integer:: stat
!!$    character(STRING):: cause_c
!!$    character(*), parameter:: subname = 'DCHistNmlSample'
!!$  continue
!!$    call BeginSub( subname )
!!$    stat = DC_NOERR
!!$    cause_c = ''
!!$
!!$    !-----------------------------------------------------------------
!!$    !  Υå
!!$    !  Check initialization
!!$    !-----------------------------------------------------------------
!!$    if ( .not. hstnml % initialized ) then
!!$      stat = DC_ENOTINIT
!!$      cause_c = 'DCHSTNML'
!!$      goto 999
!!$    end if
!!$
!!$    !-----------------------------------------------------------------
!!$    !  *hstnml* ˳ǼƤͤμФ
!!$    !  Fetch setting values stored in *hstnml*
!!$    !-----------------------------------------------------------------
!!$!!$    CoefAlpha = hstnml % CoefAlpha
!!$!!$    DelTime   = hstnml % DelTime
!!$
!!$    !-----------------------------------------------------------------
!!$    !  λ, 㳰
!!$    !  Termination and Exception handling
!!$    !-----------------------------------------------------------------
!!$999 continue
!!$    call StoreError( stat, subname, err, cause_c )
!!$    call EndSub( subname )
!!$  end subroutine DCHistNmlSample

end module dc_histnml
